﻿// Copyright (c) AlphaSierraPapa for the SharpDevelop Team (for details please see \doc\copyright.txt)
// This code is distributed under the GNU LGPL (for details please see \doc\license.txt)

using System;
using System.Xml;
using System.IO;
using ICSharpCode.SharpDevelop;

namespace ICSharpCode.Reports.Addin
{
	/// <summary>
	/// Description of XmlHelper.
	/// </summary>
	internal class XmlHelper
	{
		private XmlHelper()
		{
		}
		
		
		public static XmlTextWriter CreatePropperWriter (StringWriter writer)
		{
			XmlTextWriter xml = new XmlTextWriter(writer);
			xml.Formatting = Formatting.Indented;
			xml.Indentation = 4;
			return xml;
		}
		
		
		public static void CreatePropperDocument (XmlTextWriter writer)
		{
			writer.WriteStartDocument();
			writer.WriteStartElement("ReportModel");
			writer.WriteStartElement("ReportSettings");
		}
	}
}