﻿// Copyright (c) AlphaSierraPapa for the SharpDevelop Team (for details please see \doc\copyright.txt)
// This code is distributed under the GNU LGPL (for details please see \doc\license.txt)

using System;
using ICSharpCode.WixBinding;
using NUnit.Framework;
using WixBinding.Tests.Utils;

namespace WixBinding.Tests.PackageFiles
{
	public abstract class ActiveViewChangedWhenPackageFilesOpenTestFixtureBase
	{
		protected MockWorkbench workbench;
		protected MockWixPackageFilesControl packageFilesControl;
		protected PackageFilesView packageFilesView;
		protected WixDocument document;
		protected WixProject project;
		protected MockTextEditorViewContent viewWithOpenWixDocument;
		
		[SetUp]
		public void Init()
		{
			viewWithOpenWixDocument = new MockTextEditorViewContent();
			viewWithOpenWixDocument.SetFileName(@"d:\projects\test\a.wxs");
			
			workbench = new MockWorkbench();
			workbench.ViewContentCollection.Add(viewWithOpenWixDocument);
			
			document = new WixDocument();
			document.FileName = @"d:\projects\test\a.wxs";
			
			packageFilesControl = new MockWixPackageFilesControl();
			packageFilesControl.Document = document;
			
			project = WixBindingTestsHelper.CreateEmptyWixProject();
			packageFilesView = new PackageFilesView(project, workbench, packageFilesControl);
			
			AfterInit();
		}
		
		protected abstract void AfterInit();
		
		[TearDown]
		public void TearDown()
		{
			packageFilesView.Dispose();
		}

	}
}
